
#include "properties/ImplicitIndex.hh"
#include "Exceptions.hh"

using namespace cadabra;

std::string ImplicitIndex::name() const
	{
	return "ImplicitIndex";
	}

bool ImplicitIndex::parse(const Kernel&, keyval_t& keyvals)
	{
	keyval_t::const_iterator ki=keyvals.begin();
	while(ki!=keyvals.end()) {
//		std::cout << "ImplicitIndex: " << ki->first << " = " << *ki->second->name << std::endl;
		if(ki->first=="name") {
			if(*ki->second->multiplier!=1) {
				throw std::logic_error("ImplicitIndex: use quotes to label names when they start with a number.");
				}
			set_names.push_back(*ki->second->name);
			}
		else throw ConsistencyException("Property 'ImplicitIndex' does not accept key '"+ki->first+"'.");
		++ki;
		}

	return true;
	}

void ImplicitIndex::latex(std::ostream& str) const
	{
	property::latex(str);
	for(size_t n=0; n<set_names.size(); ++n) {
		if(n>0) str << ", ";
		str << set_names[n];
		}
	}
